package xyz.tbvns.Models;

import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.ModelInstance;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import xyz.tbvns.LevelInfo;

@Data
@NoArgsConstructor
public class GDInstance {
    public GDInstance(ModelInstance instance, String name, String id) {
        this.instance = instance;
        this.name = name;
        this.id = id;
        this.animation = false;
    }

    public GDInstance(ModelInstance instance, int fps, int frameSkip, double start, String name, String id, Animation animation) {
        this.instance = instance;
        this.fps = fps;
        this.frameSkip = frameSkip;
        this.start = start;
        this.name = name;
        this.id = id;
        this.animation = true;
        this.animationObject = animation;
        this.expanded = false;
    }

    public void updateFrame(double percent) {
        instance = new ModelInstance(getFrameOnPercent(percent), instance.transform);
        instance.userData = this;
    }

    //TODO: This doesn't work, repair later
    public Model getFrameOnPercent(double percent) {
        double usablePercent = percent - (start / 100);
        if (usablePercent > 0) {
            float max = LevelInfo.getLevel().getMaxPos();
            double speed = LevelInfo.getLevel().getSpeedAt((float) percent);
            //Animation length in second
            //TODO: MAKE THIS WORK + add a function to convert percentage to time with correct estimation pf speed (
            double fullTime = (double) animationObject.getFrames().size() / 24;
            int frame = 0;
            if (!(frame > animationObject.getModelFrames().size() - 1)) {
                System.out.println(frame);
                return animationObject.getModelFrames().get(frame);
            }
            return animationObject.getModelFrames().getLast();
        }
        return animationObject.getModelFrames().getFirst();
    }

    private ModelInstance instance;
    private boolean animation;
    private double start;
    private int current;
    private int fps, frameSkip;
    //TODO: add keyframes
    private String name, id;
    private boolean expanded;
    private Animation animationObject;
}
